JAVA代码编写
给定一个数组 prices
,它的第 i
个元素 prices[i]
表示一支给定股票第 i
天的价格。
你只能选择 某一天 买入这只股票,并选择在 未来的某一个不同的日子 卖出该股票。设计一个算法来计算你所能获取的最大利润。
返回你可以从这笔交易中获取的最大利润。如果你不能获取任何利润,返回 0
。
示例 1:
输入:[7,1,5,3,6,4]
输出:5
解释:在第 2 天(股票价格 = 1)的时候买入,在第 5 天(股票价格 = 6)的时候卖出,最大利润 = 6-1 = 5 。
注意利润不能是 7-1 = 6, 因为卖出价格需要大于买入价格;同时,你不能在买入前卖出股票。
示例 2:
输入:prices = [7,6,4,3,1]
输出:0
解释:在这种情况下, 没有交易完成, 所以最大利润为 0。
提示:
1 <= prices.length <= 105
0 <= prices[i] <= 104
教程:https://programmercarl.com/0121.%E4%B9%B0%E5%8D%96%E8%82%A1%E7%A5%A8%E7%9A%84%E6%9C%80%E4%BD%B3%E6%97%B6%E6%9C%BA.html
思路:之前使用的贪心做的122. 买卖股票的最佳时机 II。
这里规定在某一天买入股票,未来的某一天卖出。股票的价格就是物品,但是要分买入和卖出,这个算多重背包嘛。
五部曲:
1.定义数组
dp[i] [0] 表示第i天持有股票所得最多现金 ,这里可能有同学疑惑,本题中只能买卖一次,持有股票之后哪还有现金呢?
其实一开始现金是0,那么加入第i天买入股票现金就是 -prices[i], 这是一个负数。
dp[i] [1] 表示第i天不持有股票所得最多现金
2.递推公式
如果第i天持有股票即dp[i] [0], 那么可以由两个状态推出来
那么dp[i] [0]应该选所得现金最大的,所以dp[i] [0] = max(dp[i - 1] [0], -prices[i]);
如果第i天不持有股票即dp[i] [1], 也可以由两个状态推出来
同样dp[i] [1]取最大的,dp[i] [1] = max(dp[i - 1] [1], prices[i] + dp[i - 1] [0]);
3.dp数组如何初始化
由递推公式 dp[i] [0] = max(dp[i - 1] [0], -prices[i]); 和 dp[i] [1] = max(dp[i - 1] [1], prices[i] + dp[i - 1] [0]);可以看出
其基础都是要从dp[0] [0]和dp[0] [1]推导出来。
那么dp[0] [0]表示第0天持有股票,此时的持有股票就一定是买入股票了,因为不可能有前一天推出来,所以dp[0] [0] -= prices[0];
dp[0] [1]表示第0天不持有股票,不持有股票那么现金就是0,所以dp[0] [1] = 0;
4.确定遍历顺序
从递推公式可以看出dp[i]都是由dp[i - 1]推导出来的,那么一定是从前向后遍历。
5.举例推导dp数组
以示例1,输入:[7,1,5,3,6,4]为例,dp数组状态如下:
复杂度分析:
class Solution {
public int maxProfit(int[] prices) {
if (prices == null || prices.length == 0) return 0;
int length = prices.length;
// dp[i][0]代表第i天持有股票的最大收益
// dp[i][1]代表第i天不持有股票的最大收益
int[][] dp = new int[length][2];
int result = 0;
dp[0][0] = -prices[0];
dp[0][1] = 0;
for (int i = 1; i < length; i++) {
dp[i][0] = Math.max(dp[i - 1][0], -prices[i]);
dp[i][1] = Math.max(dp[i - 1][0] + prices[i], dp[i - 1][1]);
}
return dp[length - 1][1];
}
public static void main(String[] args) {
Solution solution = new Solution();
solution.maxProfit(new int[]{7,1,5,3,6,4});
}
}
给你一个整数数组 prices
,其中 prices[i]
表示某支股票第 i
天的价格。
在每一天,你可以决定是否购买和/或出售股票。你在任何时候 最多 只能持有 一股 股票。你也可以先购买,然后在 同一天 出售。
返回 你能获得的 最大 利润 。
示例 1:
输入:prices = [7,1,5,3,6,4]
输出:7
解释:在第 2 天(股票价格 = 1)的时候买入,在第 3 天(股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5 - 1 = 4 。
随后,在第 4 天(股票价格 = 3)的时候买入,在第 5 天(股票价格 = 6)的时候卖出, 这笔交易所能获得利润 = 6 - 3 = 3 。
总利润为 4 + 3 = 7 。
示例 2:
输入:prices = [1,2,3,4,5]
输出:4
解释:在第 1 天(股票价格 = 1)的时候买入,在第 5 天 (股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5 - 1 = 4 。
总利润为 4 。
示例 3:
输入:prices = [7,6,4,3,1]
输出:0
解释:在这种情况下, 交易无法获得正利润,所以不参与交易可以获得最大利润,最大利润为 0 。
提示:
1 <= prices.length <= 3 * 104
0 <= prices[i] <= 104
教程:https://programmercarl.com/0122.%E4%B9%B0%E5%8D%96%E8%82%A1%E7%A5%A8%E7%9A%84%E6%9C%80%E4%BD%B3%E6%97%B6%E6%9C%BAII.html
思路:每一天只能进行买和卖,但是只有先买才能卖。最多只能持有一股股票。贪心算法,只收集每天的正利润。
class Solution {
public int maxProfit(int[] prices) {
int profit=0;
for(int i = 0; i < prices.length-1; i++){
int v = prices[i+1]-prices[i];
if(v>0){
profit += v;
}
}
return profit;
}
}
思路:
这里规定在某一天买入股票,未来的某一天卖出。多次买卖。
五部曲:
1.定义数组dp[j]:1-j天买卖股票的最大利润为dp[j]
2.递推公式
dp[j],按照股票价格索引j来,假设j=0时有价格,就是有意义的。
dp[0]=0 因为第0天,光买不能卖,稳亏,只能不买是最赚的。
dp[1]=prices[0] > prices[1] ?0:prices[1]-prices[0] 这个时候,只能第0天买,第1天卖,如果第1天小于第0天的价格,那就不卖。
dp[i] = (dp[i-1]==0 && prices[i-1]>prices[i] )?0:Math.max(dp[i-1],prices[i]-prices[i-1]+dp[i-1]);
如果上一个利润还是0,且当前的prices还是递减数列,那当前dp[i]还是等于0;否则,就上一个利润和上一个累积利润的最大值。自己写的,力扣通过了,有点开心。都是数学归纳法。
3.dp数组如何初始化
int[] dp = new int[prices.length+1];
dp[0]=0;
dp[1]=prices[0] > prices[1] ? 0 : prices[1]-prices[0];
4.遍历循序:从前向后
5.举例推导dp数组
以prices = [7,1,5,3,6,4]
为例子
j | 0 | 1 | 2 | 3 | 4 | 5 |
---|---|---|---|---|---|---|
dp[j] | 0 | 0 | 4 | 4 | 7 | 7 |
复杂度分析:
class Solution {
public int maxProfit(int[] prices) {
if(prices.length==0||prices==null|| prices.length==1) return 0;
if (prices.length==2) {
if (prices[0]>prices[1]) {
return 0;
}else return prices[1]-prices[0];
}
int[] dp = new int[prices.length+1];
dp[0]=0;
dp[1]=prices[0] > prices[1] ? 0 : prices[1]-prices[0];
for (int i = 2; i < prices.length; i++) {
dp[i] = (dp[i-1]==0 && prices[i-1]>prices[i] )?0:Math.max(dp[i-1],prices[i]-prices[i-1]+dp[i-1]);
}
return dp[prices.length-1];
}
public static void main(String[] args) {
Solution solution = new Solution();
solution.maxProfit(new int[]{7,1,5,3,6,4});
}
}